package com.allmycode.p05_01_02

import android.content.res.Configuration
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle

import android.net.Uri
import android.opengl.Visibility
import android.telecom.Call
import android.telecom.CallRedirectionService
import android.view.View
import androidx.navigation.*
import androidx.navigation.fragment.NavHostFragment
import kotlinx.android.synthetic.main.activity_main.*


class MainActivity : AppCompatActivity(),
    MainEntry.OnFragmentInteractionListener,
    DoStuff.OnFragmentInteractionListener,
    personalInfo.OnFragmentInteractionListener,
    creditCard.OnFragmentInteractionListener,
    finalize.OnFragmentInteractionListener,
    SeeResults.OnFragmentInteractionListener,
    SayGoodbye.OnFragmentInteractionListener {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
    }

    override fun onFragmentInteraction(uri: Uri) {

    }

    override fun onConfigurationChanged(newConfig: Configuration) {
        if (newConfig.orientation ==
            Configuration.ORIENTATION_LANDSCAPE) {

            LastChange.setText("Landscape")
        } else if (newConfig.orientation ==
            Configuration.ORIENTATION_PORTRAIT) {

            LastChange.setText("Portrait")
        } else {
            LastChange.setText("Unrecognized")
        }
        super.onConfigurationChanged(newConfig)
    }

    fun onDestination1Click(view: View){
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments: NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment
        val ChildFragment =
            Fragments.childFragmentManager.fragments[0]

        val thisCaller = navController.currentDestination
        Caller.setText("Caller: " + thisCaller!!.label)

        when (ChildFragment) {
            is MainEntry -> navController.navigate(
                R.id.action_mainEntry_to_doStuff)
            is DoStuff ->  navController.navigate(
                R.id.action_doStuff_to_personalInfo)
            is personalInfo -> navController.navigate(
                R.id.action_personalInfo_to_creditCard)
            is creditCard -> navController.navigate(
                R.id.action_creditCard_to_finalize)
            is finalize -> navController.navigate(
                R.id.action_finalize_to_seeResults)
            is SeeResults -> navController.navigate(
                R.id.action_seeResults_to_sayGoodbye)
        }

        ChangeButtons(navController)
    }

    fun onDestination2Click(view: View){
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments: NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment
        val ChildFragment =
            Fragments.childFragmentManager.fragments[0]

        val thisCaller = navController.currentDestination
        Caller.setText("Caller: " + thisCaller!!.label)

        when (ChildFragment) {
            is MainEntry -> navController.navigate(
                R.id.action_mainEntry_to_seeResults)
             is finalize -> navController.navigate(
                 R.id.action_finalize_to_sayGoodbye)
        }

        ChangeButtons(navController)
    }

    fun onPreviousClick(view: View) {
        val navController = Navigation.findNavController(
            this, R.id.nav_host)
        val Fragments: NavHostFragment =
            supportFragmentManager.findFragmentById(
                R.id.nav_host) as NavHostFragment

        val thisCaller = navController.currentDestination
        Caller.setText("Caller: " + thisCaller!!.label)

        navController.navigateUp()
        ChangeButtons(navController)
    }

    fun ChangeButtons(navController: NavController) {
        val newCaller =
            navController.currentDestination!!.arguments
        if (newCaller!!["Button1"] != null) {
            Destination1.visibility = View.VISIBLE
            Destination1.setText(
                newCaller!!["Button1"]!!.defaultValue.toString()
            )
        } else
            Destination1.visibility = View.INVISIBLE

        if (newCaller!!["Button2"] != null) {
            Destination2.visibility = View.VISIBLE
            Destination2.setText(
                newCaller!!["Button2"]!!.defaultValue.toString()
            )
        } else
            Destination2.visibility = View.INVISIBLE
    }
}
